<template>
  <div class="risk-numbers" v-if="info.length">
    <table class="risk-table">
      <thead>
        <tr>
          <th>Наименование группы</th>
          <th>
            Числовой эквивалент
            <ObTooltip
              content="Степень влияния значения поля на общую оценку клиента. Проще говоря, чем больше число, тем выше вероятность попадания клиента в эту группу"
            >
              <i class="icon blue question" style="font-size: 12px" />
            </ObTooltip>
          </th>
          <th>Кол-во клиентов</th>
          <th></th>
          <th></th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="item in info" :key="item.uuid">
          <td>
            <risk :color="item.risk_color"/>
          </td>
          <td>
            <ObInput v-model="item.assessment"/>
          </td>
          <td>
            {{ item.clientsCount }}
          </td>
          <td>
            <a href="#" v-if="item.clientsCount > 0" @click.prevent="showClients(item)">
              Посмотреть
              <i class="icon blue external-link" style="font-size: 12px"></i>
            </a>
          </td>
          <td></td>
        </tr>
      </tbody>
    </table>
    <div class="footer">
      <ob-button label="Отменить" type="flat" @click="onReset"/>
      <ob-button label="Cохранить" type="primary" @click="onSave"/>
    </div>
    <ob-modal
      ref="showClients"
      title="Клиенты"
      :is-show-controls="false"
      :isOnlyClose="true"
      customClass="clients-modal"
    >
      <div class="client" v-for="(client, index) in clientsToShow" :key="index">
        {{ client }}
      </div>
    </ob-modal>
  </div>
</template>

<script>
  import api from '@/api';
  import cloneDeep from 'clone-deep'
  import ObInput from "common-components/src/obComponents/obInput"
  import ObButton from 'common-components/src/obComponents/obButton'
  import Risk from '../components/Risk'
  import ObModal from "common-components/src/obComponents/obModal"
  import ObTooltip from "common-components/src/obComponents/obTooltip"

  export default {
    name: "numbersTab",

    components: {
      ObInput,
      ObButton,
      Risk,
      ObModal,
      ObTooltip
    },

    created() {
      api.risks.getNumbers()
        .then(({ data }) => {
          this.info = data.domainRiskGroupsAssessmentsList
          this.backUp = cloneDeep(this.info)
        }).catch((e) => {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      })
    },

    data() {
      return {
        info: [],
        backUp: [],
        clientsToShow: null
      }
    },

    methods: {
      showClients(item) {
        this.clientsToShow = item.clients
        this.$refs.showClients.open()
      },

      onSave() {},

      onReset() {
        this.info = cloneDeep(this.backUp)
      }
    }
  }
</script>

<style lang="scss">

  .clients-modal {
    max-height: 95vh;
    overflow: auto;
  }

</style>

<style lang="scss" scoped>
  .risk-table {

    th {
      text-align: left;
    }

    th:first-child {
      padding-left: 14px;
    }

    th:nth-child(3) {
      text-align: center;
    }

    th, td {
      padding-left: 14px;
      padding-right: 14px;
    }

    td:first-child {
      width: 27%;
    }

    td:nth-child(2) {
      width: 9%;
    }

    td:nth-child(3) {
      width: 20%;
      text-align: center;
    }
  }

  .el-tooltip {
    display: inline-block;
    vertical-align: middle;
  }

  .icon.blue {
    color: $color-blue-navy-blue;
  }

  .client {
    padding: 1em 0;

    &:not(:last-child) {
      border-bottom: 1px solid $lavender;
    }
  }
</style>
